<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Todd Riggins">
   <meta name="GENERATOR" content="Mozilla/4.61 [en] (Win98; I) [Netscape]">
   <title>EXOTICA: INPUT</title>
</head>
<body background="images/exotica_bg.gif" bgcolor="#000000" text="#ffffff">
<center>
<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="maroon"><font size=+2>
<a NAME="INPUT"></a>EXOTICA: INPUT
</font></font></b></center></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="black">
Contents<br>
47 routines<p>
<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Integration:<br>
<A href="e_dinput.html#Integration">Integration with Windows</A><p>
DirectInput Control Routines:<br>
<A href="e_dinput.html#DINPUT_INIT">DINPUT_INIT</A><br>
<A href="e_dinput.html#DINPUT_UPDATE">DINPUT_UPDATE</A><br>
<A href="e_dinput.html#REAQUIRE_INPUT">REAQUIRE_INPUT</A><br>
<A href="e_dinput.html#DINPUT_RELEASE">DINPUT_RELEASE</A><p>
Keyboard Routines:<br>
<A href="e_dinput.html#KEYBOARD_INIT">KEYBOARD_INIT</A><br>
<A href="e_dinput.html#KEYBOARD_KEYSTATE">KEYBOARD_KEYSTATE</A><br>
<A href="e_dinput.html#GET_KB_BUFFER_EVENTS">GET_KB_BUFFER_EVENTS</A><br>
<A href="e_dinput.html#GET_KB_BUFFER_DATA">GET_KB_BUFFER_DATA</A><br>
<A href="e_dinput.html#KEYBOARD_RELEASE">KEYBOARD_RELEASE</A><p>
Mouse Routines:<br>
<A href="e_dinput.html#MOUSE_INIT">MOUSE_INIT</A><br>
<A href="e_dinput.html#MOUSE_X">MOUSE_X</A><br>
<A href="e_dinput.html#MOUSE_Y">MOUSE_Y</A><br>
<A href="e_dinput.html#MOUSE_Z">MOUSE_Z</A><br>
<A href="e_dinput.html#MOUSE_B0">MOUSE_B0 through _B7</A><br>
<A href="e_dinput.html#MOUSE_RELEASE">MOUSE_RELEASE</A><p>
Joystick Routines:<br>
<A href="e_dinput.html#JOYSTICK_INIT">JOYSTICK_INIT</A><br>
<A href="e_dinput.html#JOY_X_AXIS">JOY_X_AXIS</A><br>
<A href="e_dinput.html#JOY_Y_AXIS">JOY_Y_AXIS</A><br>
<A href="e_dinput.html#JOY_Z_AXIS">JOY_Z_AXIS</A><br>
<A href="e_dinput.html#JOY_RX_AXIS">JOY_RX_AXIS</A><br>
<A href="e_dinput.html#JOY_RY_AXIS">JOY_RY_AXIS</A><br>
<A href="e_dinput.html#JOY_RZ_AXIS">JOY_RZ_AXIS</A><br>
<A href="e_dinput.html#JOY_SLIDER">JOY_SLIDER</A><br>
<A href="e_dinput.html#JOY_POV">JOY_POV</A><br>
<A href="e_dinput.html#JOY_BUTTON">JOY_BUTTON</A><br>
<A href="e_dinput.html#JOYSTICK_RELEASE">JOYSTICK_RELEASE</A><br>
--<br>
<A href="e_dinput.html#Interpreting">Interpreting Joystick Axis Data</A><br>
<A href="e_dinput.html#JOY_X_RANGE">JOY_X_RANGE</A><br>
<A href="e_dinput.html#JOY_Y_RANGE">JOY_Y_RANGE</A><br>
<A href="e_dinput.html#JOY_Z_RANGE">JOY_Z_RANGE</A><br>
<A href="e_dinput.html#JOY_RX_RANGE">JOY_RX_RANGE</A><br>
<A href="e_dinput.html#JOY_RY_RANGE">JOY_RY_RANGE</A><br>
<A href="e_dinput.html#JOY_RZ_RANGE">JOY_RZ_RANGE</A><br>
<A href="e_dinput.html#JOY_SLIDER_RANGE">JOY_SLIDER_RANGE</A><br>
<A href="e_dinput.html#JOY_X_DEADZONE">JOY_X_DEADZONE</A><br>
<A href="e_dinput.html#JOY_Y_DEADZONE">JOY_Y_DEADZONE</A><br>
<A href="e_dinput.html#JOY_Z_DEADZONE">JOY_Z_DEADZONE</A><br>
<A href="e_dinput.html#JOY_RX_DEADZONE">JOY_RX_DEADZONE</A><br>
<A href="e_dinput.html#JOY_RY_DEADZONE">JOY_RY_DEADZONE</A><br>
<A href="e_dinput.html#JOY_RZ_DEADZONE">JOY_RZ_DEADZONE</A><br>
<A href="e_dinput.html#JOY_X_SATURATION">JOY_X_SATURATION</A><br>
<A href="e_dinput.html#JOY_Y_SATURATION">JOY_Y_SATURATION</A><br>
<A href="e_dinput.html#JOY_Z_SATURATION">JOY_Z_SATURATION</A><br>
<A href="e_dinput.html#JOY_RX_SATURATION">JOY_RX_SATURATION</A><br>
<A href="e_dinput.html#JOY_RY_SATURATION">JOY_RY_SATURATION</A><br>
<A href="e_dinput.html#JOY_RZ_SATURATION">JOY_RZ_SATURATION</A><p>
Control Panel:<br>
<A href="e_dinput.html#JOYSTICK_CONTROL_PANEL">JOYSTICK_CONTROL_PANEL</A><br>
</font></b></td></tr>
</table>
</font></b></center></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Integration<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="Integration"></a><center><font color="Maroon">Integration with Windows</font></center>
<hr WIDTH="100%">
This quote is taken from the DirectX7.0 SDK:<p>
&quot;<i><b>Integration with Windows</b><p>
Because DirectInput works directly with the device drivers, it either suppresses or
ignores mouse and keyboard messages. When using the mouse in exclusive mode, DirectInput
suppresses mouse messages, and therefore Windows is unable to show the standard cursor. <p>
DirectInput also ignores mouse and keyboard settings made by the user in Control Panel.<p>
For the keyboard, character repeat settings are not used by DirectInput. When using
buffered data, DirectInput interprets each press and release as a single event, with
no repetition. When using immediate data, DirectInput is concerned only with the present
physical state of the keys, not with keyboard events as interpreted by Windows.<p>
For the mouse, DirectInput ignores Control Panel settings such as acceleration and
swapped buttons. Again, DirectInput works directly with the mouse driver, bypassing the
subsystem of Windows that interprets mouse data for windowed applications.<p>
<b>Note</b>  Settings in the driver itself are recognized by DirectInput. For example, if 
the user has a three-button mouse and uses the driver-utility software to make the middle
button a double-click shortcut, DirectInput reports a click of the middle button as two
clicks of the primary button.<p>
For a joystick or other game controller, DirectInput does use the calibrations set by the
user in Control Panel</i>.&quot;<br>
<hr WIDTH="100%">
So with that in mind, if you want to use the regular windows mouse, keyboard or joystick
events returned by window messages, make sure DirectInput isn't being used in your program.
If you are using DirectInput and say you have a multiplayer game and need a chat parser or
some other kind of parser that you need to enter text the regular way, release the 
DirectInput by calling the DINPUT_RELEASE function, do your text parser, then when that's
done, call DINPUT_INIT again to get DirectInput working and you also will have to 
call KEYBOARD_INIT, MOUSE_INIT and/or JOYSTICK_INIT if you are currently using them in
your program. If you call the JOYSTICK_INIT function again, you will have to reset
the characterics of the joystick again to get the normal RANGE,DEADZONE and SATURATION
you expect.<p>
I will be making more joystick routines to handle a forcefeedback joystick in the near(?) future.<p>
Also, you won't be able to use the Windows regular keyboard services when DirectInput is
initialized.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
DirectInput Control Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="DINPUT_INIT"></a><center><font color="Maroon">DINPUT_INIT</font></center>
<hr WIDTH="100%">
C: int DINPUT_INIT( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(DINPUT_INIT,{NULL}) <br>
<hr WIDTH="100%">
Description: Initializes DirectX's DirectInput in order to use the keyboard, joystick and mouse. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="DINPUT_UPDATE"></a><center><font color="Maroon">DINPUT_UPDATE</font></center>
<hr WIDTH="100%">
C: void DINPUT_UPDATE( void )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(DINPUT_UPDATE,{NULL})<br>
<hr WIDTH="100%">
Description: You must poll for input from any of the DirectInput's objects(Keyboard, Mouse, Joystick) in order to
retrieve any input data that you may need.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="REAQUIRE_INPUT"></a><center><font color="Maroon">REAQUIRE_INPUT</font></center>
<hr WIDTH="100%">
C: void REAQUIRE_INPUT( void )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(REAQUIRE_INPUT,{NULL})<br>
<hr WIDTH="100%">
Description: Used in the emain.ew wndproc() function when user does the alt-tab back to prgram.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="DINPUT_RELEASE"></a><center><font color="Maroon">DINPUT_RELEASE</font></center>
<hr WIDTH="100%">
C: void DINPUT_RELEASE( void ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(DINPUT_RELEASE,{NULL}) <br>
<hr WIDTH="100%">
Description: Frees DirectInput which was initialized with DINPUT_INIT.<br>
<hr WIDTH="100%">
Note: You don't have to call this routine. EXOTICA_EXIT will make sure
DirectInput and all of it's components are released. Also, if you had initialized
the joystick, mouse and/or keyboard with the JOYSTICK_INIT, MOUSE_INIT and/or KEYBOARD_INIT
routines, then they will also get released as well because they need DirectInput to 
be initialized for use.<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Keyboard Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="KEYBOARD_INIT"></a><center><font color="Maroon">KEYBOARD_INIT</font></center>
<hr WIDTH="100%">
C: void KEYBOARD_INIT( int Mode ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(KEYBOARD_INIT,{ Mode }) <br>
<hr WIDTH="100%">
Description: Initializes DirectInput to use the Keyboard. <br>
<hr WIDTH="100%">
Mode:<br>
&nbsp;0 = Immediate Data: Returns immediate data from keyboard. Could loose key info.<br>
&nbsp;1 = Buffered Data: Keeps pressed key data in a buffer. Requires a little bit more
coding to return data. See: Keybuff.exw example<br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; 0 = success<br> 
&nbsp; 1 = failure<p> 
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="KEYBOARD_KEYSTATE"></a><center><font color="Maroon">KEYBOARD_KEYSTATE</font></center>
<hr WIDTH="100%">
C: int KEYBOARD_KEYSTATE( int Key_Value ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(KEYBOARD_KEYSTATE,{Key_Value}) <br>
<hr WIDTH="100%">
Description: Checks the return state of the key specified by the scan code give in the Key_Value parameter.
You can refer to the Euphoria's <i>exotica_api.ew</i> or C's <i>emain.h</i> file to look at what Keyboard scan codes that are available to use.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_KB_BUFFER_EVENTS"></a><center><font color="Maroon">GET_KB_BUFFER_EVENTS</font></center>
<hr WIDTH="100%">
C: DWORD GET_KB_BUFFER_EVENTS( void )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_KB_BUFFER_EVENTS,{NULL})<p>
<hr WIDTH="100%">
Description: returns how many current elements(buffered keystrokes) in the buffer.
must be used with the DINPUT_UPDATE routine.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="GET_KB_BUFFER_DATA"></a><center><font color="Maroon">GET_KB_BUFFER_DATA</font></center>
<hr WIDTH="100%">
C: int GET_KB_BUFFER_DATA( DWORD element, DWORD [DIK_KEY] )<br>
<hr WIDTH="100%">
Euphoria Function: c_func(GET_KB_BUFFER_DATA,{element, [DIK_KEY]})<br>
<hr WIDTH="100%">
Description: returns 1 if the specified DIK KEY is in the buffer. You can use a for loop
to check for what specified dik keys are pressed by entering the for variable in the
element paramenter. Please look at the <i>keybuff</i> example for an example how to do this.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="KEYBOARD_RELEASE"></a><center><font color="Maroon">KEYBOARD_RELEASE</font></center>
<hr WIDTH="100%">
C: void KEYBOARD_RELEASE( void ) <br>
<hr WIDTH="100%">
Procedure: c_proc(KEYBOARD_RELEASE,{NULL}) <br>
<hr WIDTH="100%">
Description: Frees the DirectInput's Keyboard Object which was initialized with KEYBOARD_INIT.
Note: You don't have to call this routine. EXOTICA_EXIT will make sure
DirectInput and all of it's objects is released. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Mouse Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="MOUSE_INIT"></a><center><font color="Maroon">MOUSE_INIT</font></center>
<hr WIDTH="100%">
C: int MOUSE_INIT( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(MOUSE_INIT,{NULL}) <br>
<hr WIDTH="100%">
Description: Initializes DirectInput to use the Mouse. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="MOUSE_X"></a><center><font color="Maroon">MOUSE_X</font></center>
<hr WIDTH="100%">
C: LONG MOUSE_X( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(MOUSE_X,{NULL}) <br>
<hr WIDTH="100%">
Description: returns the mouse x coordinates <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="MOUSE_Y"></a><center><font color="Maroon">MOUSE_Y</font></center>
<hr WIDTH="100%">
C: LONG MOUSE_Y( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(MOUSE_Y,{NULL}) <br>
<hr WIDTH="100%">
Description: returns the mouse y coordinates <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="MOUSE_Z"></a><center><font color="Maroon">MOUSE_Z</font></center>
<hr WIDTH="100%">
C: LONG MOUSE_Z( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(MOUSE_Z,{NULL}) <br>
<hr WIDTH="100%">
Description: returns the mouse z coordinates. (Which is the wheel if your mouse has one)<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="MOUSE_B0"></a><center><font color="Maroon">MOUSE_B0 through _B7</font></center>
<hr WIDTH="100%">
DirectX has included 4 more button states for the mouse to use if you
ever get a mouse with 8 buttons on it. Crazy, I say... So, yes, you
now have 8 routines to check each mouse button state.<br>
which are: MOUSE_B0, MOUSE_B1, MOUSE_B2, MOUSE_B3, MOUSE_B4, MOUSE_B5, MOUSE_B6, MOUSE_B7<p>
<hr WIDTH="100%">
C: int MOUSE_B0( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(MOUSE_B0,{NULL}) <br>
<hr WIDTH="100%">
Description: returns the state of mouse button 1. <br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; 0 = Not pressed<br>
&nbsp; 1 = Pressed<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="MOUSE_RELEASE"></a><center><font color="Maroon">MOUSE_RELEASE</font></center>
<hr WIDTH="100%">
C: void MOUSE_RELEASE( void ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(MOUSE_RELEASE,{NULL}) <br>
<hr WIDTH="100%">
Description: Frees the DirectInput's Mouse Object which was initialized with MOUSE_INIT.
Note: You don't have to call this routine. EXOTICA_EXIT will make sure
DirectInput and all of it's objects is released. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Joystick Routines<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOYSTICK_INIT"></a><center><font color="Maroon">JOYSTICK_INIT</font></center>
<hr WIDTH="100%">
C: int JOYSTICK_INIT( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOYSTICK_INIT,{NULL}) <br>
<hr WIDTH="100%">
Description: Initializes DirectInput to use the Joystick. <br>
<hr WIDTH="100%">
Return Value: <br>
&nbsp; 0 = success <br>
&nbsp; 1 = failure <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_X_AXIS"></a><center><font color="Maroon">JOY_X_AXIS</font></center>
<hr WIDTH="100%">
C: LONG JOY_X_AXIS( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_X_AXIS,{NULL}) <br>
<hr WIDTH="100%">
Description: returns a lateral X-axis state. <br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; -1 = Left<br>
&nbsp; 0 = Neutral<br>
&nbsp; 1 = Right<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Y_AXIS"></a><center><font color="Maroon">JOY_Y_AXIS</font></center>
<hr WIDTH="100%">
C: LONG JOY_Y_AXIS( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_Y_AXIS,{NULL}) <br>
<hr WIDTH="100%">
Description: returns a lateral Y-axis state.<br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; -1 = Up <br>
&nbsp; 0 = Neutral <br>
&nbsp; 1 = Down <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Z_AXIS"></a><center><font color="Maroon">JOY_Z_AXIS</font></center>
<hr WIDTH="100%">
C: LONG JOY_Z_AXIS( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_Z_AXIS,{NULL}) <br>
<hr WIDTH="100%">
Description: returns a lateral Z-axis state.<br>
<hr WIDTH="100%">
Return Value:<br>
&nbsp; -1 = High <br>
&nbsp; 0 = Neutral <br>
&nbsp; 1 = Low <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RX_AXIS"></a><center><font color="Maroon">JOY_RX_AXIS</font></center>
<hr WIDTH="100%">
C: LONG JOY_RX_AXIS( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_RX_AXIS,{NULL}) <br>
<hr WIDTH="100%">
Description: returns a Rotational X-axis state. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RY_AXIS"></a><center><font color="Maroon">JOY_RY_AXIS</font></center>
<hr WIDTH="100%">
C: LONG JOY_RY_AXIS( void ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_RY_AXIS,{NULL}) <br>
<hr WIDTH="100%">
Description: returns a Rotational Y-axis state. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RZ_AXIS"></a><center><font color="Maroon">JOY_RZ_AXIS</font></center>
<hr WIDTH="100%">
C: LONG JOY_RZ_AXIS( void ) <br>
<hr WIDTH="100%">
Function: c_func(JOY_RZ_AXIS,{NULL}) <br>
<hr WIDTH="100%">
Description: returns a Rotational Z-axis state. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_SLIDER"></a><center><font color="Maroon">JOY_SLIDER</font></center>
<hr WIDTH="100%">
C: LONG JOY_SLIDER( int Slider_Number ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_SLIDER,{Slider_Number}) <br>
<hr WIDTH="100%">
Description: returns a Slider state. The Slider_Number has a range of 0-1 which means you can support a joystick
that may have two sliders on it.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_POV"></a><center><font color="Maroon">JOY_POV</font></center>
<hr WIDTH="100%">
C: LONG JOY_POV( int Pov_Number ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_POV,{Pov_Number}) <br>
<hr WIDTH="100%">
Description: returns a Point-of-view state. Pov_Number has a range of 0-3 which means you can support a joystick
that may have up to 4 Point-of-view hats. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_BUTTON"></a><center><font color="Maroon">JOY_BUTTON</font></center>
<hr WIDTH="100%">
C: BYTE JOY_BUTTON( int Button_Number ) <br>
<hr WIDTH="100%">
Euphoria Function: c_func(JOY_BUTTON,{Button_Number}) <br>
<hr WIDTH="100%">
Description: returns a value from a button on the joystick. Button_Number has a range of 0-31 which means you can
support up to a 32 button joystick.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOYSTICK_RELEASE"></a><center><font color="Maroon">JOYSTICK_RELEASE</font></center>
<hr WIDTH="100%">
C: void JOYSTICK_RELEASE( void ) <br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOYSTICK_RELEASE,{NULL}) <br>
<hr WIDTH="100%">
Description: Frees the DirectInput's Joystick Object which was initialized with JOYSTICK_INIT.
Note: You don't have to call this routine. EXOTICA_EXIT will make sure
DirectInput and all of it's objects is released. <br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="Interpreting"></a><center><font color="Maroon">Interpreting Joystick Axis Data</font></center>
<hr WIDTH="100%">
RANGE routines:<br>
Sets the specified axis range of a joystick, I dont have a joystick that uses a slider, so I don't know if setting a range to a slider is possible. DirectX dosn't allow you
to set ranges on a Pov Hat.<p>
C Example:<p>
&nbsp;JOY_X_RANGE(-10000, 10000);<p>
Euphoria Example:<p>
&nbsp;c_proc(JOY_X_RANGE,{-10000, 10000})<p>

The above example will assign it a range between -10000 and 10000. When the x-axis is centered on your joystick, the JOY_X_AXIS routine will return a 0.
When the joystick is pressed right, the JOY_X_AXIS will return a maxium value of 10000 and if press left the min value will be -10000. If your joystick is digital,
you will only get a value of 10000, 0 or -10000. If your joystick is analog, you will get different values depending on the positioning of the x-axis on your joystick
within the range you specified. Another thing, the center value is basically the sum of the min and max values then divided by 2. So if you specified 0 for min and
6000 for max, the center value will be 3000.<br>
<hr WIDTH="100%">

DEADZONE:<br>
[Sets the deadzone of a specified axis]<p>
C Example:<p>
&nbsp;JOY_X_DEADZONE(1000);<p>
Euphoria Example:<p>
&nbsp;c_proc(JOY_X_DEADZONE,{1000})<p>
With the above example, if you had assigned JOY_X_RANGE with -10000 & 10000, then the JOY_X_DEADZONE will assign 10% of the axis traveled(1000 of
10000 is 10%). The dead zone affects the center area of the axis applied to. Setting the dead zone doesn't truncate the range. It compresses it into a smaller part of
the physical range of the axis. So, when the stick leaves leaves the dead zone, the full range of values is applied to the remaining physical range of travel.<br>
<hr WIDTH="100%">

SATURATION:<br>
[Sets the Saturation of a specified axis]<p>
C Example:<p>
&nbsp;JOY_X_SATURATION(9000)<p>
Euphoria Example:<p>
&nbsp;c_proc(JOY_X_SATURATION,{9000})<p>
The saturation works just like the dead zone, but at the limits of the axis rather then the center. A saturation zone is a useful way of compensating for small
differences in the extreme vaues reported with the stick in various positions. For example, the max x-axis might report a different value at the upper right corner,
center right and the lower right corner of the joystick. If no staturation zone where created with a program that used a JOY_X_AXIS range of -1000 to 1000, then
DirectInput would return a value of 1000 only in the position for which the driver returned the largest raw value. With the above example, if you had assigned
JOY_X_RANGE with -10000 & 10000, then the JOY_X_SATURATION will assign 10% of the axis traveled(10000-9000 is 1000; 1000 of 10000 is 10%). As
with the deadzone, the saturation zone isn't truncated. So when the axis is anywhere inside of this zone, the minimum or maximun value will be returned.<br>
<hr WIDTH="100%">

See Also:<br>
In C: 'Input.c' example.<br>
In Euphoria: 'Input.exw' example.<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_X_RANGE"></a><center><font color="Maroon">JOY_X_RANGE</font></center>
<hr WIDTH="100%">
C: void JOY_X_RANGE( LONG min, LONG max )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_X_RANGE,{max, min})<br>
<hr WIDTH="100%">
Description: Sets the min and max range of the x-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Y_RANGE"></a><center><font color="Maroon">JOY_Y_RANGE</font></center>
<hr WIDTH="100%">
C: void JOY_Y_RANGE( LONG min, LONG max )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_Y_RANGE,{min, max})<br>
<hr WIDTH="100%">
Description: Sets the min and max range of the y-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Z_RANGE"></a><center><font color="Maroon">JOY_Z_RANGE</font></center>
<hr WIDTH="100%">
C: void JOY_Z_RANGE( LONG min, LONG max)<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_Z_RANGE,{min, max})<br>
<hr WIDTH="100%">
Description: Sets the min and max range of the z-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RX_RANGE"></a><center><font color="Maroon">JOY_RX_RANGE</font></center>
<hr WIDTH="100%">
C: void JOY_RX_RANGE( LONG min, LONG max )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RX_RANGE,{min, max})<br>
<hr WIDTH="100%">
Description: Sets the min and max range of the rx-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RY_RANGE"></a><center><font color="Maroon">JOY_RY_RANGE</font></center>
<hr WIDTH="100%">
C: void JOY_RY_RANGE( LONG min, LONG max )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RY_RANGE,{min, max})<br>
<hr WIDTH="100%">
Description: Sets the min and max range of the ry-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RZ_RANGE"></a><center><font color="Maroon">JOY_RZ_RANGE</font></center>
<hr WIDTH="100%">
C: void JOY_RZ_RANGE( LONG min, LONG max )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RZ_RANGE,{min, max})<br>
<hr WIDTH="100%">
Description: Sets the min and max range of the rz-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_SLIDER_RANGE"></a><center><font color="Maroon">JOY_SLIDER_RANGE</font></center>
<hr WIDTH="100%">
C: void JOY_SLIDER_RANGE( int slider number, LONG min, LONG max})<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_SLIDER_RANGE,{ slider number, min, max})<br>
<hr WIDTH="100%">
Description: Sets the min and max range of a specified slider if available.
The slider number paramenter only accepts values of 0 and 1.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_X_DEADZONE"></a><center><font color="Maroon">JOY_X_DEADZONE</font></center>
<hr WIDTH="100%">
C: void JOY_X_DEADZONE( DWORD dead_zone_percentage_range )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_X_DEADZONE,{ dead_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the dead zone for the x-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Y_DEADZONE"></a><center><font color="Maroon">JOY_Y_DEADZONE</font></center>
<hr WIDTH="100%">
C: void JOY_Y_DEADZONE( DWORD dead_zone_percentage_range )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_Y_DEADZONE,{ dead_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the dead zone for the y-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Z_DEADZONE"></a><center><font color="Maroon">JOY_Z_DEADZONE</font></center>
<hr WIDTH="100%">
C: void JOY_Z_DEADZONE( DWORD dead_zone_percentage_range )<br>
<hr WIDTH="100%">
Euhporia Procedure: c_proc(JOY_Z_DEADZONE,{ dead_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the dead zone for the z-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RX_DEADZONE"></a><center><font color="Maroon">JOY_RX_DEADZONE</font></center>
<hr WIDTH="100%">
C: void JOY_RX_DEADZONE( DWORD dead_zone_percentage_range )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RX_DEADZONE,{ dead_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the dead zone for the rx-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RY_DEADZONE"></a><center><font color="Maroon">JOY_RY_DEADZONE</font></center>
<hr WIDTH="100%">
C: void JOY_RY_DEADZONE( DWORD dead_zone_percentage_range )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RY_DEADZONE,{ dead_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the dead zone for the ry-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RZ_DEADZONE"></a><center><font color="Maroon">JOY_RZ_DEADZONE</font></center>
<hr WIDTH="100%">
C: void JOY_RZ_DEADZONE( DWORD dead_zone_percentage_range )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RZ_DEADZONE,{ dead_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the dead zone for the rz-axis if available. <p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_X_SATURATION"></a><center><font color="Maroon">JOY_X_SATURATION</font></center>
<hr WIDTH="100%">
C: void JOY_X_SATURATION( DWORD saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_X_SATURATION,{ saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the saturation zone for the x-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Y_SATURATION"></a><center><font color="Maroon">JOY_Y_SATURATION</font></center>
<hr WIDTH="100%">
C: void JOY_Y_SATURATION( DWORD saturation_zone_percentage_range )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_Y_SATURATION,{ saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the saturation zone for the y-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_Z_SATURATION"></a><center><font color="Maroon">JOY_Z_SATURATION</font></center>
<hr WIDTH="100%">
C: void JOY_Z_SATURATION( DWORD saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_Z_SATURATION,{ saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the saturation zone for the z-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RX_SATURATION"></a><center><font color="Maroon">JOY_RX_SATURATION</font></center>
<hr WIDTH="100%">
C: void JOY_RX_SATURATION( DWORD saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RX_SATURATION,{ saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the saturation zone for the rx-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RY_SATURATION"></a><center><font color="Maroon">JOY_RY_SATURATION</font></center>
<hr WIDTH="100%">
C: void JOY_RY_SATURATION( DWORD saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RY_SATURATION,{ saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the saturation zone for the ry-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOY_RZ_SATURATION"></a><center><font color="Maroon">JOY_RZ_SATURATION</font></center>
<hr WIDTH="100%">
C: void JOY_RZ_SATURATION( DWORD saturation_zone_percentage_range )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOY_RZ_SATURATION,{ saturation_zone_percentage_range })<br>
<hr WIDTH="100%">
Description: Sets the saturation zone for the rz-axis if available.<p>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
Control Panel<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<a NAME="JOYSTICK_CONTROL_PANEL"></a><center><font color="Maroon">JOYSTICK_CONTROL_PANEL</font></center>
<hr WIDTH="100%">
C: void JOYSTICK_CONTROL_PANEL( void )<br>
<hr WIDTH="100%">
Euphoria Procedure: c_proc(JOYSTICK_CONTROL_PANEL,{NULL})<br>
<hr WIDTH="100%">
Description: When this function is called, your program will minimize and then the Windows
Game Controller Panel ( Located in your control panel folder ) will pop up for you to pick
and/or configure you joystick, gamepad or wheel. When you finish and close the Game
Controller Panel, you will have to manually maximize your program to get back in to it.
Your program should keep running in some way in the background while the Panel is up,
so I would suggest using this routine in a controller setup area of your program. Also note that
you need to have the appActive(for C) or aActive(for Euphoria) method to ensure that your program
does not crash if your program is blitting graphics to the screen. Remmember that when your program
minimizes, it's still going. If your program is still trying to blit graphics to the screen,
then it will crash unless you trap it from blitting graphics to the screen when the program
minimizes. <P>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>

</center>
</body>
</html>
